---
title: DataView() constructor
slug: Web/JavaScript/Reference/Global_Objects/DataView/DataView
tags:
  - Constructor
  - DataView
  - JavaScript
  - Reference
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>DataView()</code></strong> constructor is used to create {{jsxref("DataView")}} objects.</p>

<div>{{EmbedInteractiveExample("pages/js/dataview-constructor.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new DataView(<var>buffer</var> [, <var>byteOffset</var> [, <var>byteLength</var>]])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>buffer</var></code></dt>
 <dd>An existing {{jsxref("ArrayBuffer")}} or {{jsxref("SharedArrayBuffer")}} to use as the storage backing the new <code>DataView</code> object.</dd>
 <dt><code><var>byteOffset</var></code> {{optional_inline}}</dt>
 <dd>The offset, in bytes, to the first byte in the above buffer for the new view to reference. If unspecified, the buffer view starts with the first byte.</dd>
 <dt><code><var>byteLength</var></code> {{optional_inline}}</dt>
 <dd>The number of elements in the byte array. If unspecified, the view's length will match the buffer's length.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new <code>DataView</code> object representing the specified data buffer. (That probably wasn't a very helpful description.)</p>

<p>You can think of the returned object as an "interpreter" of the array buffer of bytes — it knows how to convert numbers to fit within the buffer correctly, both when reading and writing to it. This means handling integer and float conversion, endianness, and other details of representing numbers in binary form.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>{{jsxref("RangeError")}}</dt>
 <dd>
 <p>Thrown if the <code>byteOffset</code> or <code>byteLength</code> parameter values result in the view extending past the end of the buffer.</p>

 <p>For example, if the buffer is 16 bytes long, the <code>byteOffset</code> is 8, and the <code>byteLength</code> is 10, this error is thrown because the resulting view tries to extend 2 bytes past the total length of the buffer.</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_DataView">Using DataView</h3>

<pre class="brush: js notranslate">var buffer = new ArrayBuffer(16);
var view = new DataView(buffer, 0);

view.setInt16(1, 42);
view.getInt16(1); // 42
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-dataview-constructor', 'DataView constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.DataView.DataView")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("DataView")}}</li>
</ul>
